using namespace std;
#include <iostream>
#include "Fila.h"

/**
 * Preencher o código das funções pedidas
 */
 
// Contrutor de uma fila vazia
Fila::Fila() 
{
    primeiro = ultimo = NULL;
}

// Insere o cliente c no final fila
void Fila::insere(Cliente c)
{
    No *temp = new No;
    if(temp == NULL){
        cout << "Sem memoria" << endl;
        return;
    }
    temp->cliente = c;
    temp->proximo = NULL;
 
    //se primeiro no
    if(primeiro == NULL){
        primeiro = ultimo = temp;
    }
    else{
        ultimo->proximo = temp;
        ultimo = temp;
    }
}
 
// Remove o cliente que está na frente da fila
// Imprime "Fila vazia" se não existem clientes na fila
void Fila::sai()
{
    if (primeiro == NULL){
        cout << "Fila vazia" << endl;
        return;
    }
     
    if(primeiro == ultimo) // se apenas fica um no
        primeiro = ultimo = NULL;
    else
        primeiro = primeiro->proximo;
}

// Imprime a fila
// Deve imprimir "Fila vazia" - se não existem cliente na fila
// Deve imprimir a fila no formato: "Inicio: Nome,Nº de rodutos; Nome, Nº; ... ;" 
// Exemplo "Inicio: Maria,5; Pedro,10; Susana,20;"
void Fila::imprime_fila()
{
    if(primeiro==NULL){
        cout << "Fila vazia" << endl;
        return;
    }
    No *temp = primeiro;
    
    cout << "Inicio:";
    
    while(temp){
        cout << " " << temp->cliente.nome << ";" << temp->cliente.num_produtos << ";";
        temp = temp->proximo;
    }
    cout << endl;
}

// Devolve o número de produtos que estão no total da fila (contando todos os clientes)
int Fila::numeroProdutos()
{
    int contador = 0;
    No *temp = primeiro;
    
    while(temp){
        contador += temp->cliente.num_produtos;
        temp = temp->proximo;
    }
    return contador;
}
    
// Devolve o número de clientes que estão na fila
int Fila::numeroClientes()
{
    int contador = 0;
    No *temp = primeiro;
    
    while(temp){
        contador++;
        temp = temp->proximo;
    }
    return contador;
}

// Devolve o nome do cliente que está na fila com maior numero de produtos
// Se existirem clientes com igual número devem devolver o primeiro que encontram
// Se fila estiver vazia devem devolver "Fila vazia"
string Fila::clienteMaisProdutos() 
{
    if(primeiro==NULL)
        return "Fila vazia";
        
    int maior_num = primeiro->cliente.num_produtos;
    string nome_maior = primeiro->cliente.nome;
    No *temp = primeiro;
    
    while(temp){
        if (temp->cliente.num_produtos > maior_num) {
            maior_num = temp->cliente.num_produtos;
            nome_maior = temp->cliente.nome;
        }
        temp = temp->proximo;
    }
    return nome_maior;
}
    
// Destrutor da fila
Fila::~Fila()
{
    while(primeiro != NULL)
    {
        No *temp = primeiro;
        primeiro = primeiro->proximo;
        delete temp;
    }
    ultimo=NULL;
}
